# Testextension for Issue 77296 and Review 49260

## Installation and testmenus

This extension provides three static templates with different 
menu configurations and testcases on the different levels.
 
- Testmenu - TopLevelCheck 
- Testmenu - subMenu working in 6.2, broken in 7.6
- Testmenu - subMenu new getter
 
The second one, subMenu working in 6.2, broken in 7.6 simulates
the real workcase we had, and what was broken in 7.6.

### Testmen - TopLevelCheck

This checks for the parentMenuArr in the topLevelMenu (firt TMENU).
In 6.2 parentMenuArr was not defined as class member, and not filled,
and as such was not defined in that case.

With the patch, the public member should be an empty array.

### Testmenu - subMenu working in 6.2, broken in 7.6

This simulates the workcase we had, and which was broken after
the upgrade from 6.2 to 7.6.

On the first/topLevel we set the ITEM_STATES, and in some cases
USERDEF1 and USERDEF2, as such all ITEM_STATES where set, when the
was parsed from the subMenu itemArrayProcFunc.

Note: Manuel setting this in the first itemArrayProcFunc was done, because
      the itemState render is done AFTER the subMenu(s) are renderd for
      the current menu level. 
      
In Typo 7.6 the parentMenuArr was complety removed and never set, why our
itemArrayProcFunc construct stopped working.

With the patch, our itemArrayProcFunc's working again.

Netherless public members are bad things in some cases, new setter 
and getter where implementend as improvement and as better
replacment for the public class member parentMenuArr. 

See next section.

### Testmenu - subMenu new getter

Note:   This only works, if the patch is applied.

The patch provides two getter functions, to retrieve the
parentMenuArr and the direkt parent menu item, without the
need to loop through the parentMenuArr, as done currently
by our working construct.

```
/** @var \TYPO3\CMS\Frontend\ContentObject\Menu\AbstractMenuContentObject $parentObj */
$parentObj      = $conf['parentObj'];

// get the whole parent menu arr
$parentMenuArr  = $parentObj->getParentMenuArr();

// get the direct parent menu item directly,
// without parsing the parent menuArr array again
// and matching the page
$parentMenuItem = $parentObj->getParentMenuItem();
```

The difference is, getParentMenuArr() will always return
an array, empty if it is the first menu level.

parentMenuItems returns null if first level, otherwise
the array from the parentMenuArr, which is the direct 
parent menu item.
